/*
 * CREATING TABLES
 */
CREATE TABLE EMPLOYEE(
	EMPLOYEE_ID NUMBER(9) PRIMARY KEY,
	NAME VARCHAR2(100) NOT NULL,
	EMAIL VARCHAR2(100) UNIQUE
);

CREATE TABLE PROJECT(
	PROJECT_ID NUMBER(9) PRIMARY KEY, -- THIS IS EQUIVALENT TO SETTING A UNIQUE AND NON NULL CONSTRAINT ON THIS COLUMN
	DESCRIPTION VARCHAR(100),
	BUDGET NUMBER(10,2) -- 99999999.99
);

/*
 * CONSTRAINTS CAN BE CREATED WHEN CREATING TABLES, BUT THE 
 * TABLES CAN ALSO BE ALTERED TO ADD THEM IN LATER
 */
ALTER TABLE EMPLOYEE 
MODIFY (NAME NOT NULL); 

ALTER TABLE EMPLOYEE 
ADD CONSTRAINT EMP_UNQ UNIQUE (EMAIL);

/*
 * OUR JUNCTION TABLE INCLUDES A COMPOSITE KEY AND 
 * TWO FOREIGN KEYS 
 */
CREATE TABLE EMPLOYEE_PROJECT(
	EMPLOYEE_ID NUMBER(9) REFERENCES EMPLOYEE,
	PROJECT_ID NUMBER(9) REFERENCES PROJECT,
	CONSTRAINT E_P_PK PRIMARY KEY (EMPLOYEE_ID, PROJECT_ID)
)

/*
 * DROP IS ANOTHER DDL COMMAND
 */
DROP TABLE EMPLOYEE;

DROP TABLE EMPLOYEE_PROJECT;

TRUNCATE TABLE EMPLOYEE_PROJECT;

TRUNCATE TABLE EMPLOYEE;

-- ADDING DATA WITH DML
INSERT INTO PROJECT VALUES (1,'BAKERY APPLICATION', 3000)
INSERT INTO PROJECT VALUES (2,'BAKERY APPLICATION', 4000)
INSERT INTO PROJECT (PROJECT_ID, DESCRIPTION) VALUES (3, 'SOCIAL MEDIA') 

-- attempting to add a constraint on data which does not follow it
ALTER TABLE PROJECT 
ADD CONSTRAINT PROJ_UNQ UNIQUE (DESCRIPTION); -- THIS DOESN'T WORK IF DATA CAN'T CURRENTLY BE VALIDATED AGAINST THE CONSTRAINT

-- updating a single record (don't forget the where clause!)
UPDATE PROJECT 
SET DESCRIPTION = 'BAKERY APPLICATION'
WHERE PROJECT_ID = 1

INSERT INTO EMPLOYEE VALUES (101, 'Jack','jack@google.com')

INSERT INTO EMPLOYEE VALUES (102, 'Kira','kjr@google.com')

INSERT INTO EMPLOYEE VALUES (103, 'Lola','lola@company.com')

INSERT INTO EMPLOYEE VALUES (104, 'Harold','h.arold@google.com')

INSERT INTO EMPLOYEE VALUES (105, 'Ferdinand','ferdy@google.com')

INSERT INTO EMPLOYEE_PROJECT VALUES (101,1);
INSERT INTO EMPLOYEE_PROJECT VALUES (102,2);
INSERT INTO EMPLOYEE_PROJECT VALUES (104,2);
INSERT INTO EMPLOYEE_PROJECT VALUES (105,3);
--INSERT INTO EMPLOYEE_PROJECT VALUES (105,4);

DELETE FROM EMPLOYEE 
WHERE EMPLOYEE_ID = 105;

DELETE FROM EMPLOYEE_PROJECT
WHERE EMPLOYEE_ID = 105;

UPDATE EMPLOYEE 
SET NAME='Harry', EMAIL='harry@gmail.com'
WHERE EMPLOYEE_ID = 104;







-- DOUBLE QUOTES USED FOR ALIAS